// InDlg.cpp : implementation file
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////

#include "stdafx.h"
#include "pathsim.h"
#include "InDlg.h"
#include "pathsimdoc.h"
#include "wave.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInDlg dialog


CInDlg::CInDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInDlg)
	m_InputSelect = 0;
	m_HSCWTxt = _T("");
	m_HSCWSpeed = 4000;
	m_HSCWFreq = 2000;
	//}}AFX_DATA_INIT
}


void CInDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInDlg)
	DDX_Control(pDX, IDC_HSCWSPIN2, m_HSCWSpin2Ctrl);
	DDX_Control(pDX, IDC_HSCWCFREQ, m_HSCWFreqCtrl);
	DDX_Control(pDX, IDC_HSCWSPIN, m_HSCWSpinCtrl);
	DDX_Control(pDX, IDC_HSCWEDIT, m_HSCWEditCtrl);
	DDX_Control(pDX, IDC_HSCWSPEEDTXT, m_HSCWSpeedCtrl);
	DDX_Control(pDX, IDC_INFILEINFO, m_InFileInfoCtrl);
	DDX_Control(pDX, IDC_INFILESEL, m_InFileSelectCtrl);
	DDX_Control(pDX, IDC_INFILENAME, m_InFileNameCtrl);
	DDX_Radio(pDX, IDC_SOUNDIN, m_InputSelect);
	DDX_Text(pDX, IDC_HSCWEDIT, m_HSCWTxt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInDlg, CDialog)
	//{{AFX_MSG_MAP(CInDlg)
	ON_BN_CLICKED(IDC_INFILESEL, OnInfilesel)
	ON_BN_CLICKED(IDC_SOUNDIN, OnSoundin)
	ON_BN_CLICKED(IDC_WAVEIN, OnWavein)
	ON_BN_CLICKED(IDC_IN_INTERNAL, OnHSCWin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_HSCWSPIN, OnDeltaposHscwspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_HSCWSPIN2, OnDeltaposHscwspin2)
	ON_BN_CLICKED(IDC_IN_INTERNAL2, OnFSK441In)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInDlg message handlers

BOOL CInDlg::OnInitDialog() 
{
CString str;
	CDialog::OnInitDialog();
	switch(m_InputSelect)
	{
		case USE_SOUNDCARD:
			m_InFileNameCtrl.EnableWindow(FALSE);
			m_InFileInfoCtrl.EnableWindow(FALSE);
			m_InFileSelectCtrl.EnableWindow(FALSE);
			m_HSCWEditCtrl.EnableWindow(FALSE);
			m_HSCWSpinCtrl.EnableWindow(FALSE);
			m_HSCWSpin2Ctrl.EnableWindow(FALSE);
			break;
		case USE_HSCW:
			m_InFileNameCtrl.EnableWindow(FALSE);
			m_InFileInfoCtrl.EnableWindow(FALSE);
			m_InFileSelectCtrl.EnableWindow(FALSE);
			break;
		case USE_WAVEFILE:
			m_HSCWEditCtrl.EnableWindow(FALSE);
			m_HSCWSpinCtrl.EnableWindow(FALSE);
			m_HSCWSpin2Ctrl.EnableWindow(FALSE);
			break;
		case USE_FSK441:
			m_InFileNameCtrl.EnableWindow(FALSE);
			m_InFileInfoCtrl.EnableWindow(FALSE);
			m_InFileSelectCtrl.EnableWindow(FALSE);
			m_HSCWSpinCtrl.EnableWindow(FALSE);
			m_HSCWSpin2Ctrl.EnableWindow(FALSE);
			break;
	}
	m_InFileNameCtrl.SetWindowText(m_InFilePath);
	m_InFileInfoCtrl.SetWindowText(m_InFileInfo);
	str.Format("%d LPM,  %d wpm",m_HSCWSpeed,m_HSCWSpeed/5);
	m_HSCWSpeedCtrl.SetWindowText(str);
	str.Format("%d Hz",m_HSCWFreq);
	m_HSCWFreqCtrl.SetWindowText(str);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CInDlg::OnInfilesel() 
{
//  handler code here for getting Input filename
CString sFilter = "Wave Files (*.wav)|*.wav||";
CFileDialog Dlgfile( TRUE, "wav", m_InFilePath, 
			OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
			(LPCTSTR)sFilter, this );
	m_InFileLength = 0;
	if( Dlgfile.DoModal() == IDOK)
	{
		m_InFilePath = Dlgfile.GetPathName();
		m_InFileName = Dlgfile.GetFileName();
		m_InFileInfo = GetFileInfo(m_InFilePath);
	}
	m_InFileNameCtrl.SetWindowText(m_InFilePath);
	m_InFileInfoCtrl.SetWindowText(m_InFileInfo);
}

void CInDlg::OnSoundin() 
{
	m_InFileNameCtrl.EnableWindow(FALSE);
	m_InFileInfoCtrl.EnableWindow(FALSE);
	m_InFileSelectCtrl.EnableWindow(FALSE);
	m_HSCWEditCtrl.EnableWindow(FALSE);
	m_HSCWSpinCtrl.EnableWindow(FALSE);
	m_HSCWSpin2Ctrl.EnableWindow(FALSE);
}

void CInDlg::OnHSCWin() 
{
	m_InFileNameCtrl.EnableWindow(FALSE);
	m_InFileInfoCtrl.EnableWindow(FALSE);
	m_InFileSelectCtrl.EnableWindow(FALSE);
	m_HSCWEditCtrl.EnableWindow(TRUE);
	m_HSCWSpinCtrl.EnableWindow(TRUE);
	m_HSCWSpin2Ctrl.EnableWindow(TRUE);
}
void CInDlg::OnFSK441In() 
{
	m_InFileNameCtrl.EnableWindow(FALSE);
	m_InFileInfoCtrl.EnableWindow(FALSE);
	m_InFileSelectCtrl.EnableWindow(FALSE);
	m_HSCWEditCtrl.EnableWindow(TRUE);
	m_HSCWSpinCtrl.EnableWindow(FALSE);
	m_HSCWSpin2Ctrl.EnableWindow(FALSE);
	
}

void CInDlg::OnWavein() 
{
	m_InFileNameCtrl.EnableWindow(TRUE);
	m_InFileInfoCtrl.EnableWindow(TRUE);
	m_InFileSelectCtrl.EnableWindow(TRUE);
	m_HSCWEditCtrl.EnableWindow(FALSE);
	m_HSCWSpinCtrl.EnableWindow(FALSE);
	m_HSCWSpin2Ctrl.EnableWindow(FALSE);
}

CString CInDlg::GetFileInfo(CString path)
{
INT ErrorCode;
DWORD FileLength;
CWave TWave;
CString info = _T("Unknown error");
WAVEFORMATEX wfx;
	ErrorCode = TWave.InOpen( &path,	&wfx,0, &FileLength );
	TWave.InClose();

	if( !ErrorCode )
	{
		if( (wfx.nSamplesPerSec != 8000) ||
			(wfx.nChannels != 1) ||
			(wfx.wBitsPerSample != 16) )
		{
			info = _T("* Not 16 bit,8KHz,Mono");
		}
		else
		{
			m_InFileLength = FileLength;
			info.Format("%10.1fKS %5.1fMin", (float)FileLength/1000,
							(float)FileLength/(8000.0*60.0) );
		}
	}
	else
	{
		switch( ErrorCode ){
			case WAVIN_ERR_OPEN:
				info = _T("* Can't Open File");
				break;
			case WAVIN_ERR_NOTWAVE:
				info = _T("* Not a Wave File");
			break;
			case WAVIN_ERR_INVALID:
				info = _T("* Invalid Wave File");
				break;
			case WAVIN_ERR_NODATA:
				info = _T("* No Data in Wave File");
				break;
			case WAVIN_ERR_NOTSUPPORTED:
				info = _T("* Not Supported Wave Type in");
				break;
		}
	}
	return info;
}

void CInDlg::OnDeltaposHscwspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
CString str;
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);			// get latest value from edit box
	if(m_HSCWSpeed < 200 )
	{
		m_HSCWSpeed = m_HSCWSpeed - pNMUpDown->iDelta;
	}
	else
	{
		m_HSCWSpeed = 10*(m_HSCWSpeed/10);
		m_HSCWSpeed = m_HSCWSpeed - (10*pNMUpDown->iDelta);
	}
	if(m_HSCWSpeed>20000)
		m_HSCWSpeed = 20000;
	if(m_HSCWSpeed < 50)
		m_HSCWSpeed = 50;
	str.Format("%d LPM,  %d wpm",m_HSCWSpeed,m_HSCWSpeed/5);
	m_HSCWSpeedCtrl.SetWindowText(str);
	*pResult = 0;
}

void CInDlg::OnDeltaposHscwspin2(NMHDR* pNMHDR, LRESULT* pResult) 
{
CString str;
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);			// get latest value from edit box
	m_HSCWFreq = m_HSCWFreq - (100*pNMUpDown->iDelta);
	if(m_HSCWFreq>3000)
		m_HSCWFreq = 3000;
	if(m_HSCWFreq < 500)
		m_HSCWFreq = 500;
	str.Format("%d Hz",m_HSCWFreq);
	m_HSCWFreqCtrl.SetWindowText(str);
	*pResult = 0;
}

