// LPIIR.h: interface for the CLPIIR class.
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LPIIR_H__489894A1_6621_11D4_B4E9_704A50C10000__INCLUDED_)
#define AFX_LPIIR_H__489894A1_6621_11D4_B4E9_704A50C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <math.h>


class CLPIIR  
{
public:
	double CalcFilter(double in);
	double IIRFilter1( double in );
	double IIRFilter2(double in);
	void Init( const double* pLPCoef);
	CLPIIR();
	virtual ~CLPIIR();
private:
	double m_W1;
	double m_IIR1_A1;
	double m_IIR1_B0;
	double m_IIR1_B1;
	double m_W2[2];
	double m_IIR2_A1;
	double m_IIR2_A2;
	double m_IIR2_B0;
	double m_IIR2_B1;
	double m_IIR2_B2;
};

#endif // !defined(AFX_LPIIR_H__489894A1_6621_11D4_B4E9_704A50C10000__INCLUDED_)
