// Path.h: interface for the CPath class.
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_PATH_H__B0F00FA0_6587_11D4_B4E9_E02350C10000__INCLUDED_)
#define AFX_PATH_H__B0F00FA0_6587_11D4_B4E9_E02350C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h>
#include "rand.h"

class CPath  
{
public:
	INT CalcPath( _complex* pIn, _complex* pOut);
	void InitPath( INT Epm, INT Amp, INT Length, double DopShift,
					 INT blocksize, BOOL active, BOOL RandEpm,
					 BOOL RandAmp, BOOL RandLenght, BOOL RandDop);
	CPath();
	virtual ~CPath();

private:
	double m_MaxAmpTime;
	double m_DopInc;
	INT m_Epm;
	double GetRandom(double min, double max);
	CRand Rndgen;
	double m_EventT1;
	double m_EventT2;
	double m_Amax;
	double m_FRate;
	double m_ETime;
	double m_DopTimeinc;
	BOOL ProcessEvent(_complex In, _complex &Out);
	void CalcEventMetrics(void);
	double m_EventAmp;
	double m_EventDoppler;
	double m_EventLength;
	double m_Length;
	BOOL m_EventActive;
	INT m_TriggerCounter;
	BOOL CheckForEvent();
	INT m_RandTrigThreshold;
	BOOL m_PathActive;
	INT m_BlockSize;
	BOOL m_UseRandEPM;
	BOOL m_UseRandAmp;
	BOOL m_UseRandLength;
	BOOL m_UseRandDop;
};

#endif // !defined(AFX_PATH_H__B0F00FA0_6587_11D4_B4E9_E02350C10000__INCLUDED_)
