// PathSimView.cpp : implementation of the CPathSimView class
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////

#include "stdafx.h"
#include "PathSim.h"
#include "PathSimDoc.h"
#include "PathSimView.h"
#include "InDlg.h"
#include "OutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifdef TESTMODE
extern double testfreq;
extern double gDebug1;
extern double gDebug2;
extern INT iDebug3;
#endif


/////////////////////////////////////////////////////////////////////////////
// CPathSimView

IMPLEMENT_DYNCREATE(CPathSimView, CFormView)

BEGIN_MESSAGE_MAP(CPathSimView, CFormView)
	//{{AFX_MSG_MAP(CPathSimView)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_INSELECT, OnInselect)
	ON_BN_CLICKED(IDC_OUTSELECT, OnOutselect)
	ON_EN_KILLFOCUS(IDC_EDITTITLE, OnKillfocusEdittitle)
	ON_EN_KILLFOCUS(IDC_EDITRUNTIME, OnKillfocusEditruntime)
	ON_BN_CLICKED(IDC_USEDELAYSTART, OnUsedelaystart)
	ON_EN_KILLFOCUS(IDC_STARTEDIT_HOUR, OnKillfocusStarteditHour)
	ON_EN_KILLFOCUS(IDC_STARTEDIT_MIN, OnKillfocusStarteditMin)
	ON_BN_CLICKED(IDC_AWGNONOFF, OnPathChange)
	ON_WM_MOUSEMOVE()
	ON_NOTIFY(UDN_DELTAPOS, IDC_SNRSPIN, OnDeltaposSnrspin)
	ON_EN_KILLFOCUS(IDC_EDITSNR, OnKillfocusEditsnr)
	ON_EN_KILLFOCUS(IDC_EDIT_AMP, OnKillfocusEditAmp)
	ON_EN_KILLFOCUS(IDC_EDIT_DOP, OnKillfocusEditDop)
	ON_EN_KILLFOCUS(IDC_EDIT_EPM, OnKillfocusEditEpm)
	ON_EN_KILLFOCUS(IDC_EDIT_LENGTH, OnKillfocusEditLength)
	ON_BN_CLICKED(IDC_PATHON, OnPathChange)
	ON_BN_CLICKED(IDC_RAND_AMP, OnRandAmp)
	ON_BN_CLICKED(IDC_RAND_DOP, OnRandDop)
	ON_BN_CLICKED(IDC_RAND_EPM, OnRandEpm)
	ON_BN_CLICKED(IDC_RAND_LENGTH, OnRandLength)
	//}}AFX_MSG_MAP
	ON_MESSAGE( MSG_DATARDY, OnDataRdy)
	ON_MESSAGE( MSG_DONE, OnDone)
	ON_MESSAGE( MSG_ERROR, OnError)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPathSimView construction/destruction

CPathSimView::CPathSimView()
	: CFormView(CPathSimView::IDD)
{
	//{{AFX_DATA_INIT(CPathSimView)
	m_AWGNOn = FALSE;
	m_SimTitle = _T("");
	m_TimeLimit = 1;
	m_UseDelayStart = FALSE;
	m_DelayStartHour = 0;
	m_DelayStartMin = 0;
	m_DiskFree = _T("");
	m_DiskNeeded = _T("");
	m_SNRSetValue = 0;
	m_RandAmpOn = FALSE;
	m_RandDopOn = FALSE;
	m_RandEpmOn = FALSE;
	m_RandLengthOn = FALSE;
	m_PathOn = TRUE;
	m_DopplerShift = 0.0;
	m_EventsPerMin = 1;
	m_Length = 100;
	m_Amplitude = 0;
	//}}AFX_DATA_INIT
	m_pCPlotData = NULL;
	m_pCIOCntrl = NULL;
}

CPathSimView::~CPathSimView()
{
}

void CPathSimView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPathSimView)
	DDX_Control(pDX, IDC_BYPASS3, m_Bypass3Ctrl);
	DDX_Control(pDX, IDC_EDITSNR, m_EditSNRCtrl);
	DDX_Control(pDX, IDC_NOISERMS, m_NoiseRMSCtrl);
	DDX_Control(pDX, IDC_SIGRMS, m_SigRMSCtrl);
	DDX_Control(pDX, IDC_SIGNALGAIN, m_SignalGainCtrl);
	DDX_Control(pDX, IDC_AWGNGAIN, m_AWGNGainCtrl);
	DDX_Control(pDX, IDC_TESTTEXT1, m_TestTextCtrl1);
	DDX_Control(pDX, IDC_TESTTEXT2, m_TestTextCtrl2);
	DDX_Control(pDX, IDC_FFTFREQ, m_FFTFreqCtrl);
	DDX_Control(pDX, IDC_BYPASS2, m_Bypass2Ctrl);
	DDX_Control(pDX, IDC_BYPASS1, m_Bypass1Ctrl);
	DDX_Control(pDX, IDC_OUT_FILE, m_OutFileCtrl);
	DDX_Control(pDX, IDC_OUT_INFO, m_OutInfoCtrl);
	DDX_Control(pDX, IDC_IN_FILE, m_InFileCtrl);
	DDX_Control(pDX, IDC_IN_INFO, m_InInfoCtrl);
	DDX_Control(pDX, IDC_STOP, m_StopCtrl);
	DDX_Control(pDX, IDC_START, m_StartCtrl);
	DDX_Check(pDX, IDC_AWGNONOFF, m_AWGNOn);
	DDX_Text(pDX, IDC_EDITTITLE, m_SimTitle);
	DDV_MaxChars(pDX, m_SimTitle, 40);
	DDX_Text(pDX, IDC_EDITRUNTIME, m_TimeLimit);
	DDV_MinMaxInt(pDX, m_TimeLimit, 0, 500);
	DDX_Check(pDX, IDC_USEDELAYSTART, m_UseDelayStart);
	DDX_Text(pDX, IDC_STARTEDIT_HOUR, m_DelayStartHour);
	DDV_MinMaxInt(pDX, m_DelayStartHour, 0, 23);
	DDX_Text(pDX, IDC_STARTEDIT_MIN, m_DelayStartMin);
	DDV_MinMaxInt(pDX, m_DelayStartMin, 0, 59);
	DDX_Text(pDX, IDC_DISKFREE, m_DiskFree);
	DDX_Text(pDX, IDC_DISKNEEDED, m_DiskNeeded);
	DDX_Text(pDX, IDC_EDITSNR, m_SNRSetValue);
	DDX_Check(pDX, IDC_RAND_AMP, m_RandAmpOn);
	DDX_Check(pDX, IDC_RAND_DOP, m_RandDopOn);
	DDX_Check(pDX, IDC_RAND_EPM, m_RandEpmOn);
	DDX_Check(pDX, IDC_RAND_LENGTH, m_RandLengthOn);
	DDX_Check(pDX, IDC_PATHON, m_PathOn);
	DDX_Text(pDX, IDC_EDIT_DOP, m_DopplerShift);
	DDV_MinMaxDouble(pDX, m_DopplerShift, -500., 500.);
	DDX_Text(pDX, IDC_EDIT_EPM, m_EventsPerMin);
	DDV_MinMaxInt(pDX, m_EventsPerMin, 1, 100);
	DDX_Text(pDX, IDC_EDIT_LENGTH, m_Length);
	DDV_MinMaxInt(pDX, m_Length, 25, 10000);
	DDX_Text(pDX, IDC_EDIT_AMP, m_Amplitude);
	DDV_MinMaxInt(pDX, m_Amplitude, 0, 50);
	//}}AFX_DATA_MAP
}

BOOL CPathSimView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CPathSimView::OnInitialUpdate()
{
CWnd* pWnd;
CRect cr;
CPathSimDoc* pDoc = GetDocument();
CString str;
	ASSERT_VALID( pDoc);
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	//instantiate display data plotting and processing  objects
	if(!m_pCPlotData)
		m_pCPlotData = new CPlotData();	//initialize Data plotting resources
	ASSERT(m_pCPlotData);
	pWnd = GetDlgItem( IDC_PLOTFREQ );
	ASSERT_VALID(pWnd);					//give view client area to Plot object
	pWnd->GetClientRect( cr );
	m_pCPlotData->SetFreqPlotSize(cr); 
	pWnd = GetDlgItem( IDC_PLOTTIME );
	ASSERT_VALID(pWnd);					//give view client area to Plot object
	pWnd->GetClientRect( cr );
	m_pCPlotData->SetTimePlotSize(cr); 

	m_StartCtrl.EnableWindow(TRUE);
	m_StopCtrl.EnableWindow(FALSE);

	if(!m_pCIOCntrl)
		m_pCIOCntrl = new CIOCntrl();
	m_pCIOCntrl->StopIO();
// update info from document
	m_SimTitle = pDoc->m_SimTitle;
	m_TimeLimit = pDoc->m_TimeLimit/60;
	if(m_TimeLimit<=0)
	{
		m_TimeLimit = 1;
		pDoc->m_TimeLimit = 60;
	}
	m_UseDelayStart = pDoc->m_UseDelayStart;
	m_DelayStartHour = pDoc->m_DelayStartHour;
	m_DelayStartMin = pDoc->m_DelayStartMin;
	m_AWGNOn = pDoc->m_AWGNOn;
	m_SNRSetValue = pDoc->m_SNRSetValue;
	m_pCIOCntrl->SetSNRValue(m_SNRSetValue);
	m_PathOn = pDoc->m_PathOn;
	m_RandEpmOn = pDoc->m_RandEpmOn;
	m_RandAmpOn = pDoc->m_RandAmpOn;
	m_RandLengthOn = pDoc->m_RandLengthOn;
	m_RandDopOn = pDoc->m_RandDopOn;
	m_DopplerShift = pDoc->m_DopplerShift;
	m_EventsPerMin = pDoc->m_EventsPerMin;
	m_Length = pDoc->m_Length;
	m_Amplitude = pDoc->m_Amplitude;

	switch(pDoc->m_InputSelect)
	{
		case USE_WAVEFILE:
			m_InInfoCtrl.SetWindowText(	pDoc->m_InFileInfo );
			m_InFileCtrl.SetWindowText(	pDoc->m_InFileName );
			pDoc->m_InFileLength = pDoc->GetInputFileLength();

			if( pDoc->m_TimeLimit > ((UINT)pDoc->m_InFileLength/8000)+1 )
			{
				pDoc->m_TimeLimit = (pDoc->m_InFileLength/8000)+1;
				m_TimeLimit = pDoc->m_TimeLimit/60;
			}
			break;
		case USE_HSCW:
			str.Format("%d LPM,  %d wpm",pDoc->m_HSCWSpeed,pDoc->m_HSCWSpeed/5);
			m_InInfoCtrl.SetWindowText(	str);
			m_InFileCtrl.SetWindowText(	_T("HSCW Mode") );
			break;
		case USE_FSK441:
			m_InInfoCtrl.SetWindowText(	_T("FSK441"));
			m_InFileCtrl.SetWindowText(	_T("WSJT Mode") );
			break;
		case USE_SOUNDCARD:
			m_InFileCtrl.SetWindowText(	_T("SoundCard") );
			m_InInfoCtrl.SetWindowText(	_T("8KHz, 16Bit,Mono"));
			break;
	}
	if(pDoc->m_OutputSelect == USE_WAVEFILE)
	{
		str = pDoc->m_OutFileName;
		if(pDoc->m_AppendTitle)
			str.Replace( _T("."),  _T("''Title''.") );
		m_OutFileCtrl.SetWindowText( str );
		m_OutInfoCtrl.SetWindowText( _T("") );
	}
	else
	{
		m_OutFileCtrl.SetWindowText( _T("SoundCard") );
		m_OutInfoCtrl.SetWindowText( _T("8KHz, 16Bit,Mono"));
	}	pDoc->m_SimState = SIMSTATE_OFF;
	UpdateData(FALSE);
	EnableAllCtrls(TRUE);
	OnPathChange();
	UpdateDiskInfo();

}

/////////////////////////////////////////////////////////////////////////////
// CPathSimView diagnostics

#ifdef _DEBUG
void CPathSimView::AssertValid() const
{
	CFormView::AssertValid();
}

void CPathSimView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CPathSimDoc* CPathSimView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPathSimDoc)));
	return (CPathSimDoc*)m_pDocument;
}
#endif //_DEBUG

void CPathSimView::UpdateDiskInfo()
{
CPathSimDoc* pDoc;
	pDoc = GetDocument();
	pDoc->GetDiskInfo( m_DiskFree, m_DiskNeeded);
	UpdateData(FALSE);
}


/////////////////////////////////////////////////////////////////////////////
// CPathSimView message handlers

void CPathSimView::OnDestroy() 
{
	if(m_pCPlotData)
	{
		delete m_pCPlotData;
		m_pCPlotData = NULL;
	}
	if(m_pCIOCntrl)
	{
		m_pCIOCntrl->StopIO();
		delete m_pCIOCntrl;
		m_pCIOCntrl = NULL;
	}		
	CFormView::OnDestroy();
}

void CPathSimView::OnDraw(CDC* pDC) 
{
CPathSimDoc* pDoc = (CPathSimDoc*)GetDocument();
	//go recalculate & draw the data plots
	if(m_pCPlotData)
		m_pCPlotData->OnDrawPlot( m_hWnd, this, pDoc, m_pCIOCntrl );
}

void CPathSimView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_pCPlotData->CurInFreqPlot(point) )
	{
		CString str;
		INT freq = m_pCPlotData->GetCursFreq( point );
		str.Format(_T("%d Hz"),freq);
		m_FFTFreqCtrl.SetWindowText( str);
	}
	CFormView::OnMouseMove(nFlags, point);
}


//////////////////////////////////////////////////////////////////////
// Called when the process has new FFT data to display every .256 seconds.
//////////////////////////////////////////////////////////////////////
afx_msg LRESULT CPathSimView::OnDataRdy(UINT trigger, LONG y)
{
CPathSimDoc* pDoc;
CString str;
double Ngain, Sgain;
	pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	m_pCIOCntrl->ReadGains(Ngain, Sgain);
	str.Format("%g",Ngain );
	m_AWGNGainCtrl.SetWindowText( str);
	str.Format("%g", Sgain );
	m_SignalGainCtrl.SetWindowText( str);
	str.Format("%g", pDoc->m_SigRMS );
	m_SigRMSCtrl.SetWindowText( str);
	str.Format("%g", pDoc->m_NoiseRMS );
	m_NoiseRMSCtrl.SetWindowText( str);

#ifdef TESTMODE
	str.Format("%g", gDebug1);
	m_TestTextCtrl1.SetWindowText( str);
//	str.Format("%g", gDebug2);
//	m_TestTextCtrl2.SetWindowText( str);
#endif
	//go draw the data plots
	if(m_pCPlotData && ( pDoc->m_SimState==SIMSTATE_ON ))
		m_pCPlotData->DrawPlot(trigger);
	return 0;
}
//////////////////////////////////////////////////////////////////////
// Called when process has finished due to error or file done.
//////////////////////////////////////////////////////////////////////
afx_msg LRESULT CPathSimView::OnDone(UINT x, LONG y)
{
CPathSimDoc* pDoc = GetDocument();
	pDoc->m_SimState = SIMSTATE_OFF;
	m_StartCtrl.EnableWindow(TRUE);
	m_StopCtrl.EnableWindow(FALSE);
	EnableAllCtrls(TRUE);
	return 0;
}
//////////////////////////////////////////////////////////////////////
// Called when process has finished due to error or file done.
//////////////////////////////////////////////////////////////////////
afx_msg LRESULT CPathSimView::OnError(UINT x, LONG y)
{
CPathSimDoc* pDoc = GetDocument();
CString err;
	pDoc->m_SimState = SIMSTATE_ON;
	m_StartCtrl.EnableWindow(TRUE);
	m_StopCtrl.EnableWindow(FALSE);
	EnableAllCtrls(TRUE);
	m_pCIOCntrl->GetErrorMsg(err);
	::AfxMessageBox(err);
	return 0;
}

//called by clicking on the start button or if wait period is over
void CPathSimView::OnStart() 
{
CPathSimDoc* pDoc = GetDocument();
gDebug1 = 0.0;
	ASSERT(pDoc);
	if( (pDoc->m_InputSelect==USE_WAVEFILE) &&
			(pDoc->m_OutputSelect==USE_WAVEFILE))
		pDoc->m_WaveToWave = TRUE;
	else
		pDoc->m_WaveToWave = FALSE;
	switch(	pDoc->m_SimState)
	{
		case SIMSTATE_OFF:
			if(!pDoc->m_UseDelayStart)
			{
				if(m_pCPlotData)
					m_pCPlotData->SetTimeScale(pDoc->m_Length);
				if(m_pCIOCntrl)
					m_pCIOCntrl->StartIO(m_hWnd,pDoc);
				pDoc->m_StartTime = CTime::GetCurrentTime();
				pDoc->m_SimState = SIMSTATE_ON;
			}
			else
				pDoc->m_SimState = SIMSTATE_WAIT;
			break;
		case SIMSTATE_WAIT:
			if(m_pCPlotData)
				m_pCPlotData->SetTimeScale(pDoc->m_Length);
			if(m_pCIOCntrl)
				m_pCIOCntrl->StartIO(m_hWnd,pDoc);
			pDoc->m_StartTime = CTime::GetCurrentTime();
			pDoc->m_SimState = SIMSTATE_ON;
			break;
		case SIMSTATE_ON:
			break;
	}
	EnableAllCtrls(FALSE);
	m_StartCtrl.EnableWindow(FALSE);
	m_StopCtrl.EnableWindow(TRUE);
}

void CPathSimView::OnStop()
{
CPathSimDoc* pDoc = GetDocument();
	switch(	pDoc->m_SimState)
	{
		case SIMSTATE_ON:
		case SIMSTATE_WAIT:
			if(m_pCIOCntrl)
				m_pCIOCntrl->StopIO();
			pDoc->m_SimState = SIMSTATE_OFF;
			break;
		case SIMSTATE_OFF:
			break;
	}
	m_StartCtrl.EnableWindow(TRUE);
	m_StopCtrl.EnableWindow(FALSE);
	EnableAllCtrls(TRUE);
}

void CPathSimView::OnDeltaposSnrspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	UpdateData(TRUE);			// get latest SNR value from edit box
	m_SNRSetValue = m_SNRSetValue - pNMUpDown->iDelta;
	if(m_SNRSetValue>100)
		m_SNRSetValue = 100;
	if(m_SNRSetValue< -50)
		m_SNRSetValue = -50;
	GetDocument()->m_SNRSetValue = m_SNRSetValue;
	UpdateData(FALSE);			// put latest SNR value into edit box
	m_pCIOCntrl->SetSNRValue(m_SNRSetValue);
	*pResult = 0;
}
void CPathSimView::EnableAllCtrls(BOOL val)
{
CWnd* pWnd;
CPathSimDoc* pDoc = GetDocument();
	pWnd = GetDlgItem( IDC_PATHON ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_INSELECT ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_OUTSELECT ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_AWGNONOFF ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_EDITRUNTIME ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_STARTEDIT_HOUR ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val&m_UseDelayStart);
	pWnd = GetDlgItem( IDC_STARTEDIT_MIN ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val&m_UseDelayStart);
	pWnd = GetDlgItem( IDC_USEDELAYSTART ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_RAND_AMP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_RAND_DOP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_RAND_EPM ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_RAND_LENGTH ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_EDIT_AMP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_EDIT_DOP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_EDIT_EPM ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_EDIT_LENGTH ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(val);
	pWnd = GetDlgItem( IDC_EDITSNR ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_AWGNOn);
	if( m_PathOn )
	{
		m_Bypass1Ctrl.ShowWindow( SW_HIDE);
		m_Bypass2Ctrl.ShowWindow( SW_HIDE);
		m_Bypass3Ctrl.ShowWindow( SW_RESTORE);
		pDoc->m_DirectPathActive = FALSE;
	}
	else
	{
		m_Bypass1Ctrl.ShowWindow( SW_RESTORE);
		m_Bypass2Ctrl.ShowWindow( SW_RESTORE);
		m_Bypass3Ctrl.ShowWindow( SW_HIDE);
		pDoc->m_DirectPathActive = TRUE;
	}
}

void CPathSimView::OnInselect() 
{
CPathSimDoc* pDoc = GetDocument();
CInDlg dlg;
CString str;
	dlg.m_InputSelect = pDoc->m_InputSelect;
	dlg.m_InFileName = pDoc->m_InFileName;
	dlg.m_InFilePath = pDoc->m_InFilePath;
	dlg.m_InFileInfo = pDoc->m_InFileInfo;
	dlg.m_InFileLength = pDoc->m_InFileLength;
	dlg.m_HSCWSpeed = pDoc->m_HSCWSpeed;
	dlg.m_HSCWFreq = pDoc->m_HSCWFreq;
	dlg.m_HSCWTxt = pDoc->m_HSCWTxt;
	if (dlg.DoModal() == IDOK)
	{
		pDoc->m_InputSelect = dlg.m_InputSelect;
		pDoc->m_InFileName = dlg.m_InFileName;
		pDoc->m_InFilePath = dlg.m_InFilePath;
		pDoc->m_InFileInfo = dlg.m_InFileInfo;
		pDoc->m_InFileLength = dlg.m_InFileLength;
		pDoc->m_HSCWSpeed = dlg.m_HSCWSpeed;
		pDoc->m_HSCWFreq = dlg.m_HSCWFreq;
		pDoc->m_HSCWTxt = dlg.m_HSCWTxt;
	}
	switch(pDoc->m_InputSelect)
	{
		case USE_WAVEFILE:
			m_InInfoCtrl.SetWindowText(	pDoc->m_InFileInfo );
			m_InFileCtrl.SetWindowText(	pDoc->m_InFileName );
			pDoc->m_InFileLength = dlg.m_InFileLength;
			OnKillfocusEditruntime();
			break;
		case USE_HSCW:
			str.Format("%d LPM,  %d wpm",pDoc->m_HSCWSpeed,pDoc->m_HSCWSpeed/5);
			m_InInfoCtrl.SetWindowText(	str);
			m_InFileCtrl.SetWindowText(	_T("HSCW Mode") );
			break;
		case USE_FSK441:
			m_InInfoCtrl.SetWindowText(	_T("FSK441"));
			m_InFileCtrl.SetWindowText(	_T("WSJT Mode") );
			break;
		case USE_SOUNDCARD:
			m_InFileCtrl.SetWindowText(	_T("SoundCard") );
			m_InInfoCtrl.SetWindowText(	_T("8KHz, 16Bit,Mono"));
			break;
	}
}

void CPathSimView::OnOutselect() 
{
CPathSimDoc* pDoc = GetDocument();
COutDlg dlg;
CString str;
	dlg.m_OutputSelect = pDoc->m_OutputSelect;
	dlg.m_OutFilePath = pDoc->m_OutFilePath;
	dlg.m_OutFileName = pDoc->m_OutFileName;
	if (dlg.DoModal() == IDOK)
	{
		pDoc->m_OutputSelect = dlg.m_OutputSelect;
		pDoc->m_OutFilePath = dlg.m_OutFilePath;
		pDoc->m_OutFileName = dlg.m_OutFileName;
	}
	if(pDoc->m_OutputSelect == USE_WAVEFILE)
	{
		str = pDoc->m_OutFileName;
		if(pDoc->m_AppendTitle)
			str.Replace( _T("."),  _T("''Title''.") );
		m_OutFileCtrl.SetWindowText( str );
		m_OutInfoCtrl.SetWindowText( _T("") );
	}
	else
	{
		m_OutFileCtrl.SetWindowText( _T("SoundCard") );
		m_OutInfoCtrl.SetWindowText( _T("8KHz, 16Bit,Mono"));
	}
	UpdateDiskInfo();
	
}



void CPathSimView::OnKillfocusEdittitle() 
{
	UpdateData(TRUE);
	GetDocument()->m_SimTitle = m_SimTitle;
}

void CPathSimView::OnKillfocusEditruntime() 
{
CPathSimDoc* pDoc = GetDocument();
INT intime;
	UpdateData(TRUE);
	m_TimeLimit = m_TimeLimit*60;
	if(pDoc->m_InputSelect == USE_WAVEFILE)
	{
		intime = (pDoc->m_InFileLength/8000) +1;
		if( m_TimeLimit > intime )
			m_TimeLimit = intime;
	}
	pDoc->m_TimeLimit = m_TimeLimit;
	UpdateDiskInfo();
	m_TimeLimit = pDoc->m_TimeLimit/60;
	UpdateData(FALSE);
}

void CPathSimView::OnUsedelaystart() 
{
CWnd* pWnd;
	UpdateData(TRUE);
	GetDocument()->m_UseDelayStart = m_UseDelayStart;
	pWnd = GetDlgItem( IDC_STARTEDIT_HOUR ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_UseDelayStart);
	pWnd = GetDlgItem( IDC_STARTEDIT_MIN ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_UseDelayStart);
}

void CPathSimView::OnKillfocusStarteditHour() 
{
	UpdateData(TRUE);
	GetDocument()->m_DelayStartHour = m_DelayStartHour;
}

void CPathSimView::OnKillfocusStarteditMin() 
{
	UpdateData(TRUE);
	GetDocument()->m_DelayStartMin = m_DelayStartMin;
}

void CPathSimView::OnPathChange() 
{
CWnd* pWnd;
CPathSimDoc* pDoc = GetDocument();
	UpdateData(TRUE);
	pDoc->m_AWGNOn = m_AWGNOn;
	pDoc->m_PathOn = m_PathOn;
	pWnd = GetDlgItem( IDC_EDITSNR ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_AWGNOn);
	pWnd = GetDlgItem( IDC_RAND_AMP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	pWnd = GetDlgItem( IDC_RAND_DOP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	pWnd = GetDlgItem( IDC_RAND_EPM ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	pWnd = GetDlgItem( IDC_RAND_LENGTH ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	pWnd = GetDlgItem( IDC_EDIT_AMP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	pWnd = GetDlgItem( IDC_EDIT_DOP ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	pWnd = GetDlgItem( IDC_EDIT_EPM ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	pWnd = GetDlgItem( IDC_EDIT_LENGTH ); ASSERT_VALID(pWnd);
	pWnd->EnableWindow(m_PathOn);
	if( m_PathOn )
	{
		m_Bypass1Ctrl.ShowWindow( SW_HIDE);
		m_Bypass2Ctrl.ShowWindow( SW_HIDE);
		m_Bypass3Ctrl.ShowWindow( SW_RESTORE);
		pDoc->m_DirectPathActive = FALSE;
	}
	else
	{
		m_Bypass1Ctrl.ShowWindow( SW_RESTORE);
		m_Bypass2Ctrl.ShowWindow( SW_RESTORE);
		m_Bypass3Ctrl.ShowWindow( SW_HIDE);
		pDoc->m_DirectPathActive = TRUE;
	}
}

void CPathSimView::OnKillfocusEditsnr() 
{
	UpdateData(TRUE);
	GetDocument()->m_SNRSetValue = m_SNRSetValue;
	m_pCIOCntrl->SetSNRValue(m_SNRSetValue);	
}

void CPathSimView::OnKillfocusEditAmp() 
{
	UpdateData(TRUE);
	GetDocument()->m_Amplitude = m_Amplitude;
}

void CPathSimView::OnKillfocusEditDop() 
{
	UpdateData(TRUE);
	GetDocument()->m_DopplerShift = m_DopplerShift;
}

void CPathSimView::OnKillfocusEditEpm() 
{
	UpdateData(TRUE);
	GetDocument()->m_EventsPerMin = m_EventsPerMin;
}

void CPathSimView::OnKillfocusEditLength() 
{
	UpdateData(TRUE);
	GetDocument()->m_Length = m_Length;
}

void CPathSimView::OnRandAmp() 
{
	UpdateData(TRUE);
	GetDocument()->m_RandAmpOn = m_RandAmpOn;
}

void CPathSimView::OnRandDop() 
{
	UpdateData(TRUE);
	GetDocument()->m_RandDopOn = m_RandDopOn;
}

void CPathSimView::OnRandEpm() 
{
	UpdateData(TRUE);
	GetDocument()->m_RandEpmOn = m_RandEpmOn;
}

void CPathSimView::OnRandLength() 
{
	UpdateData(TRUE);
	GetDocument()->m_RandLengthOn = m_RandLengthOn;
}
