// PathSimView.h : interface of the CPathSimView class
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_PATHSIMVIEW_H__22C08F8C_5014_11D4_B4E9_802650C10000__INCLUDED_)
#define AFX_PATHSIMVIEW_H__22C08F8C_5014_11D4_B4E9_802650C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PlotData.h"
#include "IOCntrl.h"

class CPathSimView : public CFormView
{
protected: // create from serialization only
	CPathSimView();
	DECLARE_DYNCREATE(CPathSimView)

public:
	//{{AFX_DATA(CPathSimView)
	enum { IDD = IDD_METEORSIM_FORM };
	CStatic	m_Bypass3Ctrl;
	CEdit	m_EditSNRCtrl;
	CStatic	m_NoiseRMSCtrl;
	CStatic	m_SigRMSCtrl;
	CStatic	m_SignalGainCtrl;
	CStatic	m_AWGNGainCtrl;
	CStatic	m_TestTextCtrl1;
	CStatic	m_TestTextCtrl2;
	CStatic	m_FFTFreqCtrl;
	CStatic	m_Bypass2Ctrl;
	CStatic	m_Bypass1Ctrl;
	CStatic	m_OutFileCtrl;
	CStatic	m_OutInfoCtrl;
	CStatic	m_InFileCtrl;
	CStatic	m_InInfoCtrl;
	CStatic	m_RMSoutCtrl;
	CStatic	m_AWGNrmsCtrl;
	CButton	m_StopCtrl;
	CButton	m_StartCtrl;
	BOOL	m_AWGNOn;
	CString	m_SimTitle;
	int		m_TimeLimit;
	BOOL	m_UseDelayStart;
	int		m_DelayStartHour;
	int		m_DelayStartMin;
	CString	m_DiskFree;
	CString	m_DiskNeeded;
	int		m_SNRSetValue;
	BOOL	m_RandAmpOn;
	BOOL	m_RandDopOn;
	BOOL	m_RandEpmOn;
	BOOL	m_RandLengthOn;
	BOOL	m_PathOn;
	double	m_DopplerShift;
	int		m_EventsPerMin;
	int		m_Length;
	int		m_Amplitude;
	//}}AFX_DATA

// Attributes
public:
	CPathSimDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPathSimView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPathSimView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	CPlotData* m_pCPlotData;
	CIOCntrl* m_pCIOCntrl;
	void OnExStart(){ OnStart();};
	void OnExStop(){ OnStop();};
protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CPathSimView)
	afx_msg void OnDestroy();
	afx_msg void OnStart();
	afx_msg void OnStop();
	afx_msg void OnInselect();
	afx_msg void OnOutselect();
	afx_msg void OnKillfocusEdittitle();
	afx_msg void OnKillfocusEditruntime();
	afx_msg void OnUsedelaystart();
	afx_msg void OnKillfocusStarteditHour();
	afx_msg void OnKillfocusStarteditMin();
	afx_msg void OnPathChange();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDeltaposSnrspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillfocusEditsnr();
	afx_msg void OnKillfocusEditAmp();
	afx_msg void OnKillfocusEditDop();
	afx_msg void OnKillfocusEditEpm();
	afx_msg void OnKillfocusEditLength();
	afx_msg void OnRandAmp();
	afx_msg void OnRandDop();
	afx_msg void OnRandEpm();
	afx_msg void OnRandLength();
	//}}AFX_MSG
	afx_msg LRESULT OnDataRdy(UINT x, LONG y);
	afx_msg LRESULT OnDone(UINT x, LONG y);
	afx_msg LRESULT OnError(UINT x, LONG y);
	DECLARE_MESSAGE_MAP()
private:
	void UpdateDiskInfo();
	void EnableAllCtrls(BOOL val);
};


#ifndef _DEBUG  // debug version in PathSimView.cpp
inline CPathSimDoc* CPathSimView::GetDocument()
   { return (CPathSimDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PATHSIMVIEW_H__22C08F8C_5014_11D4_B4E9_802650C10000__INCLUDED_)
