// PlotData.h: interface for the CPlotData class.
//
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_PLOTDATA_H__91277FC1_4F28_11D3_A232_00A0C996E7F5__INCLUDED_)
#define AFX_PLOTDATA_H__91277FC1_4F28_11D3_A232_00A0C996E7F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PathSimDoc.h"
#include "IOCntrl.h"

#define DISPBUF_SIZE (2048)	// 2048 pt FFT 

class CPlotData  
{
public:
	void SetTimeScale(INT length);
	INT GetCursFreq(CPoint point);
	CPlotData();
	virtual ~CPlotData();
	void SetFreqPlotSize( CRect cr ){m_rFreqPlotsize = cr;};
	void SetTimePlotSize( CRect cr ){m_rTimePlotsize = cr;};
	void OnDrawPlot( HWND hWnd, CFormView* pView,CPathSimDoc* pDoc,CIOCntrl* pIOCntrl);
	BOOL CurInFreqPlot(CPoint pt){return m_rFreqPlot.PtInRect(pt);}
	BOOL CurInTimereqPlot(CPoint pt){return m_rTimePlot.PtInRect(pt);}
//	public things for access by non class worker thread
	void DrawPlot(BOOL trig);


private:
	INT m_TimeScale;
// functions
	void PlotFFTData( CDC* pDC );
	void PlotTimeData( CDC* pDC );
// variables
	BOOL m_FFTSetupChanged;
	INT m_FFTAveVal;
	INT m_TranslateTbl[1024];
	INT m_TimeTranslateTbl[2048];
	CPen* m_pPenG;			//different colored pens used for drawing plots
	CPen* m_pPenY;
	CPen* m_pPenW;
	CPen* m_pPenR;
	CPen* m_pPenC;
	CPen* m_pPenB;
	INT* m_pDispBuf;
	CRect m_rFreqPlot;			// client freq plot screen rectangle coordinates
	RECT m_rFreqPlotsize;		// size of the freq plot screen bitmap
	CBitmap m_bmFreqPlot;		// bitmap image of freq plot window
	CRect m_rTimePlot;			// client time plot screen rectangle coordinates
	RECT m_rTimePlotsize;		// size of the time plot screen bitmap
	CBitmap m_bmTimePlot;		// bitmap image of time plot window
	CPathSimDoc *m_pDoc;
	CIOCntrl* m_pIOCntrl;
	CDC* m_pDC;
	HWND m_hViewWnd;
};

#endif // !defined(AFX_PLOTDATA_H__91277FC1_4F28_11D3_A232_00A0C996E7F5__INCLUDED_)
